/**
 * Copyright 1998-2007, CHISEL Group, University of Victoria, Victoria, BC, Canada.
 * All rights reserved.
 */
package ca.uvic.csr.shrimp.ShrimpApplication.StandAloneApplication;

import java.awt.BorderLayout;

import javax.swing.JInternalFrame;

import ca.uvic.csr.shrimp.ShrimpConstants;
import ca.uvic.csr.shrimp.ShrimpProject.StandAloneProject.StandAloneProject;
import ca.uvic.csr.shrimp.gui.DesktopInternalFrame;
import ca.uvic.csr.shrimp.gui.ActionManager.ActionManager;
import ca.uvic.csr.shrimp.gui.ActionManager.CheckBoxAction;
import ca.uvic.csr.shrimp.gui.ShrimpView.AbstractShrimpViewFactory;
import ca.uvic.csr.shrimp.gui.quickview.QuickViewPanel;
import ca.uvic.csr.shrimp.usercontrols.DefaultViewAction;

class StandAloneShrimpViewFactory extends AbstractShrimpViewFactory {
	
	private ShrimpInternalFrameAdapter internalFrameAdapter;
	private StandAloneApplication standAloneApplication; 
	
	public StandAloneShrimpViewFactory(StandAloneApplication standAloneApplication) {
		super();
		this.standAloneApplication = standAloneApplication;
	}
	
	protected void projectSpecificCreateShrimpView() {
		// Add the new frame to the window menu
		CheckBoxAction chkAction = new CheckBoxAction(project.getTitle()) {
			public void startAction() {
				// show this frame and bring it to the front
				((DesktopInternalFrame)shrimpViewContainer).select();
			}
		};
		standAloneApplication.getActionManager().addAction(chkAction, "Window", "Group-B", 1);

		internalFrameAdapter = new ShrimpInternalFrameAdapter((StandAloneProject)project, chkAction);
		((DesktopInternalFrame)shrimpViewContainer).addInternalFrameListener(internalFrameAdapter);
		((DesktopInternalFrame)shrimpViewContainer).setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
		((DesktopInternalFrame)shrimpViewContainer).getContentPane().add(shrimpView.getGUI(), BorderLayout.CENTER);
        
        //create a panel of quickview buttons along the left hand side
        //Collection quickActions = new ArrayList();
        
        // quick view actions depend on the project type
//        String [] quickActionNames;
//        if (ShrimpProject.PROJECT_TYPE_PROTEGE.equals(project.getProjectType())) {
//        	quickActionNames = PROTEGE_QUICK_VIEW_ACTION_NAMES;
//        } else if (ShrimpProject.PROJECT_TYPE_OBO.equals(project.getProjectType())) {
//        	quickActionNames = OBO_QUICK_VIEW_ACTION_NAMES;
//        } else {
//        	quickActionNames = JAVA_QUICK_VIEW_ACTION_NAMES;
//        }
//        for (int i = 0; i < quickActionNames.length; i++) {
//            String actionName = quickActionNames[i];
//            Action quickAction = project.getActionManager().getAction(actionName, ShrimpConstants.MENU_QUICK_VIEWS);
//            if (quickAction != null) {
//                quickActions.add(quickAction);
//            }
//        }
        
        QuickViewPanel pnlQuickViews = new QuickViewPanel(project, null);
        ((DesktopInternalFrame)shrimpViewContainer).getContentPane().add(pnlQuickViews.getQuickViewPanel(), BorderLayout.WEST);
				
		shrimpViewContainer.setVisible(true);
		
	}
	
	/* (non-Javadoc)
     * @see ca.uvic.csr.shrimp.gui.ShrimpView.AbstractShrimpViewFactory#startAtDefaultState()
     */
    protected void startAtDefaultState() {
		new DefaultViewAction(project).startAction();
    }

	/**
	 * @see ca.uvic.csr.shrimp.gui.ShrimpView.AbstractShrimpViewFactory#projectSpecificDisposeShrimpView()
	 */
	public void projectSpecificDisposeShrimpView() {
		standAloneApplication.getActionManager().removeAction(project.getTitle(), ShrimpConstants.MENU_WINDOW, ActionManager.DISABLE_PARENT);

		((DesktopInternalFrame)shrimpViewContainer).removeInternalFrameListener(internalFrameAdapter);		
		standAloneApplication.getDesktop().remove(shrimpViewContainer);
		standAloneApplication.getDesktop().repaint();
		
		((DesktopInternalFrame)shrimpViewContainer).getContentPane().removeAll();
		internalFrameAdapter = null;
	}	

}